/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

MODUL	equ $2000				;address of RMT module
VCOUNT	equ $d40b				;vertical screen lines counter address
KEY	equ $2fc				;keypressed code
VLINE	equ 16					;screen line for synchronization

hscrol	equ $d404


scr48	= %00111111	;screen 48b
scr40	= %00111110	;screen 40b
scr32	= %00111101	;screen 32b

cloc	= $0014		;(1)
byt2	= $0000		;(1) <$0100
byt3	= $0100		;(1) >$00FF

ftmp	= $80		;(2)
regA	= ftmp+2	;(1)
regX	= regA+1	;(1)
regY	= regX+1	;(1)

hposp0	= $D000
hposp1	= $D001
hposp2	= $D002
hposp3	= $D003
hposm0	= $D004
hposm1	= $D005
hposm2	= $D006
hposm3	= $D007
sizep0	= $D008
sizep1	= $D009
sizep2	= $D00A
sizep3	= $D00B
sizem	= $D00C

colpm0	= $D012
colpm1	= $D013
colpm2	= $D014
colpm3	= $D015
color0	= $D016
color1	= $D017
color2	= $D018
color3	= $D019
colbak	= $D01A
gtictl	= $D01B

chbase	= $D409


* ---	MAIN PROGRAM
	org $4000

fntS	ins 'carun1.fnt',0,1024

fnt	ins 'yayko.fnt'

scr	ins 'yayko.scr'


dlist	dta $70,$70,$F0,$44,a(scr)
	dta $04,$04,$04,$04,$84,$84,$04,$84,$04,$84,$04,$04,$04,$84,$04,$04,$04,$84,$04,$04,$84
	dta $60,$52
ahsc	dta a(scroll)
	dta $41,a(dlist)

main
* ---	init PMG
;	mva >pmg $d407		;missiles and players data address
;	mva #3 $d01d		;enable players and missiles

	jsr save_color		;then save all colors and set value 0 for all colors

	lda:cmp:req 20		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #0 $d40e		;stop NMI interrupts
	mva #$fe $d301		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 $d40e		;switch on NMI+DLI again


	jsr fade_in		;fade in colors


	ldx #<MODUL				;low byte of RMT module to X reg
	ldy #>MODUL				;hi byte of RMT module to Y reg
	lda #0					;starting song line 0-255 to A reg
	jsr RASTERMUSICTRACKER		;Init
;Init returns instrument speed (1..4 => from 1/screen to 4/screen)
	tay
	lda tabpp-1,y
	sta acpapx2+1				;sync counter spacing
	lda #16+0
	sta acpapx1+1				;sync counter init
;
	lda #255
	sta KEY					;no key pressed
;
loop
acpapx1	lda #$ff				;parameter overwrite (sync line counter value)
	clc
acpapx2	adc #$ff				;parameter overwrite (sync line counter spacing)
	cmp #156
	bcc lop4
	sbc #156
lop4
	sta acpapx1+1
waipap
	cmp VCOUNT				;vertical line counter synchro
	bne waipap
;
	jsr RASTERMUSICTRACKER+3        	;1 play
;
	lda KEY					;keyboard
	cmp #28					;ESCape key?
	bne loop				;no => loop
;
stopmusic
	lda #255
	sta KEY				        ;no key pressed
;
	jsr RASTERMUSICTRACKER+9	        ;all sounds off
;

	jsr fade_out		;fade out colors

;	mva #0   $d01d		;PMG disabled
;	ldx #$0c\ sta $d000,x-\ rpl
	mva #$ff $d301		;ROM switch on
	mva #$40 $d40e		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled

	jmp (10)			        ;DOSVEC => exit to DOS
;

tabpp  dta 156,78,52,39			        ;line counter spacing table for instrument speed from 1 to 4


* ---	DLI PROGRAM

 ?old_dli = *

dli1
	lda $d40b
	cmp #2
	bne dli1
	:3 sta $d40a
	DLINEW dli7

dli_start
dli7

c4	lda #$3A
c5	ldx #$0C
	sta $d40a		;line=24
	sta color0
	stx color2
	DLINEW dli8

dli8

	sta $d40a		;line=72
c6	lda #$8A
	sta $d40a		;line=73
	sta color3
	DLINEW dli9

dli9

	sta $d40a		;line=80
	sta $d40a		;line=81
	sta $d40a		;line=82
c7	lda #$1A
c8	ldx #$16
	sta $d40a		;line=83
	sta color0
	stx color1
	sta $d40a		;line=84
c9	lda #$0C
c10	ldx #$1A
	sta $d40a		;line=85
	sta color0
	stx color2
	DLINEW dli2


dli2
	lda >fnt+$400*$01
	sta $d40a		;line=96
	sta chbase
	DLINEW dli10

dli10

	sta $d40a		;line=112
c11	lda #$CA
c12	ldx #$C6
	sta $d40a		;line=113
	sta color1
	stx color2
	sta $d40a		;line=114
c13	lda #$C6
c14	ldx #$0C
c15	ldy #$CE
	sta $d40a		;line=115
	sta color0
	stx color2
	sty color3
	DLINEW dli3

dli3
	lda >fnt+$400*$02
	sta $d40a		;line=144
	sta chbase
	DLINEW dli4

dli4
	lda >fnt+$400*$00
	sta $d40a		;line=176
	sta chbase
	DLINEW dli11

dli11

c16	lda #$00
	ldx >fntS
	ldy #$07
hsc	equ *-1
	sta $d40a		;line=200
	sta color2
	stx chbase
	sty hscrol
	jmp NMI.quit

;---

CHANGES

;---

.PROC NMI
	sta regA
	stx regX
	sty regY

	bit $d40f
	bpl VBL

	jmp dli_start
dliv	equ *-2

VBL
	sta $d40f		;reset NMI flag

	inc cloc		;little timer

	mwa #dlist $d402	;ANTIC address program

	mva #scr40 $d400	;set new screen's width

;--- first line of screen initialization

	lda >fnt
	sta chbase
c0	lda #$00
	sta colbak
	sta color0
c1	lda #$36
	sta color1
c2	lda #$3A
	sta color2
c3	lda #$3E
	sta color3
	lda #$04
	sta gtictl

	mwa #dli_start dliv	;set the first address of DLI interrupt


	dec hsc
	bpl _skp

	mva #$03 hsc
	inw ahsc

	.test .word ahsc = #scroll_end
	mwa #scroll ahsc
	.endt

_skp
	lda $d20f		;wait to press any key; here you can put any own routine
	and #4
	bne quit

	mva $d209 key
	
;this area is for yours routines

quit
	lda regA
	ldx regX
	ldy regY
	rti

.ENDP


;---

 opt l-

.macro DLINEW
 ift .hi(?old_dli)==.hi(:1)
  mva <:1 NMI.dliv
 els
  mwa #:1 NMI.dliv
 eif

 jmp NMI.quit

 .def ?old_dli
.endm

.macro ALIGN
 ift (*/:1)*:1<>*
  org (*/:1)*:1+:1
 eif
.endm
